# $Id: abswindow.py,v 1.2 2002/02/17 21:54:48 marijn Exp $

# An air traffic simulation game. 
# Copyright (C) 2000,1,2  Marijn Vriens <marijn@sanity.dhs.org>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import UserDict

class AbsWindow:
    def __init__(self, widget, *args):
        assert(widget)
        wl = WindowList()
        self._window = widget
        self._window.connect('delete-event', self._windowCloseButton)
        wl.register(self.__class__.WindowNickName, self)
        apply(self._build, args)
    def hide(self):
        self._window.hide()
    def show(self):
        self._window.show_all()
    def _build(self):
        pass
    def _windowCloseButton(self, widget, event=None):
        print "AbsWindow::_windowCloseButton"
        self.hide()
        return 1

def WindowList(ui=None):
    if _WindowList.instance == None:
        if(ui == None): raise "UiNeedsToBeSetFirst"
        _WindowList.instance = _WindowList(ui)
    return _WindowList.instance

class _WindowList(UserDict.UserDict):
    instance = None
    def __init__(self, ui):
        self._userInterface = ui
        UserDict.UserDict.__init__(self)
    def register(self, name, window):
        if(self.data.has_key(name)):
            if(self.data[name] is window):
                return
            else:
                raise "WindowAlreadyExists: %s" % name
        self.data[name] = window
    def getWindow(self, name):
        return self.data[name]
    def showWindow(self, name):
        self.data[name].show()
    def hideAllWindows(self):
        for w in self.data.values():
            w.hide()
    def getUserInterface(self):
        return self._userInterface
    def __setitem__(self):
        raise "NOT_SUPPORTED"


# $Log: abswindow.py,v $
# Revision 1.2  2002/02/17 21:54:48  marijn
# Windows are now hidden when closed
#
# Revision 1.1  2002/02/07 12:51:50  marijn
# Redid window referencing
#
