# $Id: dialogwin.py,v 1.1 2002/02/17 21:53:16 marijn Exp $

# An air traffic simulation game. 
# Copyright (C) 2000,1,2  Marijn Vriens <marijn@sanity.dhs.org>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import os 
import gtk

import abswindow

class DialogWin(abswindow.AbsWindow):
    WindowNickName = "dialog"
    def _build(self):
        ui = abswindow.WindowList().getUserInterface()
        self._buttonBox = ui.get_widget("dialogButtonBox")
        self._text      = ui.get_widget("dialogText")
        self._addButton("Cancel", self._windowCloseButton)
    def startMetaServer(self):
        self._text.set_text("Hmmm... It seems that the Airtraffic Meta-server is not reacting. Maybe it's not running, or you cannot reach over the network. Eitherway, I can start a local meta server.\n\nClick \"Start it\" if you want me to start one for you. else just click \"cancel\".")
        self._addButton("Start it", self._startMetaServerButton)
        self.show()
    def _startMetaServerButton(self, widget):
        cmd = "airtraffic &"
        os.popen(cmd)
        self._windowCloseButton(widget)
    def _addButton(self, name, handle):
        button = gtk.GtkButton(name)
        button.connect('clicked', handle)
        self._buttonBox.pack_end(button)
    def _windowCloseButton(self, widget, event=None):
        print "DialogWin::_windowCloseButton"
        self._window.hide()
        self._text.set_text("")
        for c in self._buttonBox.children():
            self._buttonBox.remove(c)
        self._addButton("Cancel", self._windowCloseButton)
        return 1
    def _deadHandle(self, widget):
        print "_deadHandle called"
# $Log: dialogwin.py,v $
# Revision 1.1  2002/02/17 21:53:16  marijn
# Added dialog window messages
#
