# $Id: fakedata.py,v 1.3 2002/02/18 10:49:08 marijn Exp $

# An air traffic simulation game. 
# Copyright (C) 2000,1,2  Marijn Vriens <marijn@sanity.dhs.org>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import random
import fakegtk
import abswindow
import sim

class FakeSimClient:
    def connect(self, cb, ior, nick):
        assert(ior  == 'strange string')
        assert(nick == 'tester')
    def executeWithDelay(self, delay, attrname, callback, *opts):
        assert(delay > 0)
        assert(attrname)
        assert(callback)
    def subscribe(self, callback, oid):
        assert(oid)    

class fakeWindow(abswindow.AbsWindow):
    def __init__(self, name):
        self.__class__.WindowNickName = name
        abswindow.AbsWindow.__init__(self, fakegtk.fakeGtkWindow())


def setUpUi():
    abswindow._WindowList.instance = None
    abswindow.WindowList("blah")
    fakeWindow('control')


def genSimObjType(id=None, lat=None, lon=None, vert=None, type='generic'):
    data = sim.SimulationServer.SimObjType()
    if(id):
        data.id = id
    else:
        data.id = random.randint(pow(2,30))
    data.objTypeName = type
    data.pos = genPoint(lat,lon,vert)
    return data

def genPlaneType(id=None, lat=None, lon=None, vert=None,
             speed=None, heading=None):
    data = sim.SimulationServer.PlaneType()
    if(id):
        data.id = id
    else:
        data.id = random.randint(0, pow(2,30))
    data.objTypeName = 'Plane'
    data.pos = genVector(lat,lon,vert,speed,heading)
    return data

def genPlaneTypeSet(id, lat, lon, vert, speed, heading):
    data = sim.SimulationServer.PlaneType()
    data.id = id
    data.objTypeName = 'Plane'
    data.pos = genVectorSet(lat,lon,vert,speed,heading)
    return data

def genVector(lat=None, lon=None, vert=None,
              speed=None, heading=None):
    data = sim.SimulationServer.Vector()
    if(lat):
        data.lat = lat
    else:
        data.lat = random.random()*90
    if(lon):
        data.lon = lon
    else:
        data.lon = random.random()*180
    if(vert):
        data.vert= vert
    else:
        data.vert= random.random()*40000
    if(speed):
        data.speed = speed
    else:
        data.speed  = random.random()*1000
    if(heading):
        data.heading= heading
    else:
        data.heading= random.random()*360
    return data

def genVectorSet(lat, lon, vert, speed, heading):
    data = sim.SimulationServer.Vector()
    data.lat    = lat
    data.lon    = lon
    data.vert   = vert
    data.speed  = speed
    data.heading= heading
    return data

def genPoint(lat=None, lon=None, vert=None):
    data = sim.SimulationServer.Point()
    if(lat):
        data.lat = lat
    else:
        data.lat = random.random()*90
    if(lon):
        data.lon = lon
    else:
        data.lon = random.random()*180
    if(vert):
        data.vert= vert
    else:
        data.vert= random.random()*40000
    return data


# $Log: fakedata.py,v $
# Revision 1.3  2002/02/18 10:49:08  marijn
# Updated copyright information
#
# Revision 1.2  2002/02/07 12:51:36  marijn
# Redid window referencing
#
# Revision 1.1  2002/02/01 23:55:31  marijn
# initial tests added
#
